#include <sys/param.h>
#include <sys/systm.h>
#include <sys/kernel.h>
#include <sys/queue.h>
#include <vm/uma.h>

struct umat_item {
	char data[20];
} *ui;

uma_zone_t	umat_zone;

static int
umat_modevent(module_t mod, int type, void *data)
{
	int error = 0;

	switch (type) {
	case MOD_LOAD:
		umat_zone = uma_zcreate("UMA test zone",
		    sizeof(struct umat_item),
		    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, 0);
		if (umat_zone == NULL)
			error = ENOMEM;
		ui = uma_zalloc(umat_zone, M_NOWAIT);
		if (ui == NULL)
			error = ENOMEM;
		break;
	case MOD_UNLOAD:
		uma_zfree(umat_zone, ui);
		uma_zdestroy(umat_zone);
		break;
	default:
		error = EINVAL;
		break;
	}
	
	return error;
}

static moduledata_t umat_mod = {
	"umatest",
	umat_modevent,
	0,
};

DECLARE_MODULE(umatest, umat_mod, SI_SUB_PSEUDO, SI_ORDER_ANY);
